Get a user
Namespace: microsoft.graph
Retrieve the properties and relationships of user object.
Note: Getting a user returns a default set of properties only (businessPhones, displayName, givenName, id, jobTitle, mail, mobilePhone, officeLocation, preferredLanguage, surname, userPrincipalName). Use
$selectto get the other properties and relationships for the user object.This request might have replication delays for users that were recently created, updated, or deleted.
Permissions
One of the following permissions is required to call this API. To learn more, including how to choose permissions, see Permissions.
| Permission type | Permissions (from least to most privileged) |
|---|---|
| Delegated (work or school account) | User.Read, User.ReadWrite, User.ReadBasic.All, User.Read.All, User.ReadWrite.All, Directory.Read.All, Directory.ReadWrite.All |
| Delegated (personal Microsoft account) | User.Read, User.ReadWrite |
| Application | User.Read.All, User.ReadWrite.All, Directory.Read.All, Directory.ReadWrite.All |
Tip
- Calling the
/meendpoint requires a signed-in user and therefore a delegated permission. Application permissions are not supported when using the/meendpoint. - The
User.Readpermission allows the app to read the profile, and discover relationships such as the group membership, reports and manager of the signed-in user only.
HTTP request
For a specific user:
GET /me
GET /users/{id | userPrincipalName}
Tip
- When the userPrincipalName begins with a
$character, the GET request URL syntax/users/$x@y.comfails with a400 Bad Requesterror code. This is because this request URL violates the OData URL convention, which expects only system query options to be prefixed with a$character. Remove the slash (/) after/usersand enclose the userPrincipalName in parentheses and single quotes, as follows:/users('$x@y.com'). For example,/users('$AdeleVance@contoso.com'). - To query a B2B user using the userPrincipalName, encode the hash (#) character. That is, replace the
#symbol with%23. For example,/users/AdeleVance_adatum.com%23EXT%23@contoso.com.
For the signed-in user:
GET /me
Optional query parameters
This method supports the $select OData query parameter to retrieve specific user properties, including those that are not returned by default.
By default, only a limited set of properties are returned ( businessPhones, displayName, givenName, id, jobTitle, mail, mobilePhone, officeLocation, preferredLanguage, surname, userPrincipalName ).
To return an alternative property set, you must specify the desired set of user properties using the OData $select query parameter. For example, to return displayName, givenName, and postalCode, you would use the add the following to your query $select=displayName,givenName,postalCode.
Retrieve extensions and associated data
| Extension type | Comments |
|---|---|
| onPremisesExtensionAttributes 1-15 | Returned only with $select. |
| Schema extensions | Returned only with $select. |
| Open extensions | Returned only through the Get open extension operation. |
| Directory extensions | Returned only with $select. |
Request headers
| Header | Value |
|---|---|
| Authorization | Bearer {token}. Required. |
| Content-Type | application/json |
Request body
Do not supply a request body for this method.
Response
If successful, this method returns a 200 OK response code and user object in the response body. It returns the default properties unless you use $select to specify specific properties.
This method returns 202 Accepted when the request has been processed successfully but the server requires more time to complete related background operations.
Examples
Example 1: Standard users request
Request
By default, only a limited set of properties are returned ( businessPhones, displayName, givenName, id, jobTitle, mail, mobilePhone, officeLocation, preferredLanguage, surname, userPrincipalName ). This example illustrates the default request and response.
GET https://graph.microsoft.com/v1.0/users/87d349ed-44d7-43e1-9a83-5f2406dee5bd
Response
HTTP/1.1 200 OK
Content-type: application/json
{
"businessPhones": [
"+1 425 555 0109"
],
"displayName": "Adele Vance",
"givenName": "Adele",
"jobTitle": "Retail Manager",
"mail": "AdeleV@contoso.onmicrosoft.com",
"mobilePhone": "+1 425 555 0109",
"officeLocation": "18/2111",
"preferredLanguage": "en-US",
"surname": "Vance",
"userPrincipalName": "AdeleV@contoso.onmicrosoft.com",
"id": "87d349ed-44d7-43e1-9a83-5f2406dee5bd"
}
Example 2: Signed-in user request
You can get the user information for the signed-in user by replacing /users/{id | userPrincipalName} with /me.
Request
GET https://graph.microsoft.com/v1.0/me
Response
HTTP/1.1 200 OK
Content-type: application/json
{
"businessPhones": [
"+1 425 555 0109"
],
"displayName": "Adele Vance",
"givenName": "Adele",
"jobTitle": "Retail Manager",
"mail": "AdeleV@contoso.onmicrosoft.com",
"mobilePhone": "+1 425 555 0109",
"officeLocation": "18/2111",
"preferredLanguage": "en-US",
"surname": "Vance",
"userPrincipalName": "AdeleV@contoso.onmicrosoft.com",
"id": "87d349ed-44d7-43e1-9a83-5f2406dee5bd"
}
Example 3: Use $select to retrieve specific properties of a user
To retrieve specific properties, use the OData $select query parameter. For example, to return displayName, givenName, postalCode, and identities, you would use the add the following to your query $select=displayName,givenName,postalCode,identities
Request
GET https://graph.microsoft.com/v1.0/users/87d349ed-44d7-43e1-9a83-5f2406dee5bd?$select=displayName,givenName,postalCode,identities
Response
HTTP/1.1 200 OK
Content-type: application/json
{
"@odata.context": "https://graph.microsoft.com/v1.0/$metadata#users(displayName,givenName,postalCode,identities)/$entity",
"displayName": "Adele Vance",
"givenName": "Adele",
"postalCode": "98004",
"identities": [
{
"signInType": "userPrincipalName",
"issuer": "contoso.com",
"issuerAssignedId": "AdeleV@contoso.com"
}
]
}
Example 4: Get the value of a schema extension for a user
In this example, the ID of the schema extension is ext55gb1l09_msLearnCourses.
Request
GET https://graph.microsoft.com/v1.0/users/4562bcc8-c436-4f95-b7c0-4f8ce89dca5e?$select=ext55gb1l09_msLearnCourses
Response
HTTP/1.1 200 OK
Content-type: application/json
{
"@odata.context": "https://graph.microsoft.com/v1.0/$metadata#users(ext55gb1l09_msLearnCourses)/$entity",
"ext55gb1l09_msLearnCourses": {
"@odata.type": "#microsoft.graph.ComplexExtensionValue",
"courseType": "Developer",
"courseName": "Introduction to Microsoft Graph",
"courseId": 1
}
}
Saran dan Komentar
Kirim dan lihat umpan balik untuk